=== debian/changelog ===
ros-r2b3-rclcpp (0.0.3-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 13 Sep 2017 23:52:02 -0000
