=== debian/control ===
Source: ros-r2b3-rclcpp
Section: misc
Priority: extra
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-r2b3-ament-cmake, ros-r2b3-ament-cmake-gtest, ros-r2b3-ament-lint-auto, ros-r2b3-ament-lint-common, ros-r2b3-builtin-interfaces, ros-r2b3-rcl, ros-r2b3-rcl-interfaces, ros-r2b3-rmw, ros-r2b3-rmw-implementation, ros-r2b3-rmw-implementation-cmake, ros-r2b3-rosidl-generator-cpp, ros-r2b3-rosidl-typesupport-c, ros-r2b3-rosidl-typesupport-cpp, ros-r2b3-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-r2b3-rclcpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-r2b3-ament-cmake, ros-r2b3-builtin-interfaces, ros-r2b3-rcl, ros-r2b3-rcl-interfaces, ros-r2b3-rmw, ros-r2b3-rmw-implementation, ros-r2b3-rosidl-generator-cpp, ros-r2b3-rosidl-typesupport-c, ros-r2b3-rosidl-typesupport-cpp, ros-r2b3-ros-workspace
Description: The ROS client library in C++.
